#include "leastconn"

unsigned Leastconn::target(struct in_addr clientip,
			   BackendVector const &targetlist) {

    PROFILE("Leastconn::target");
    msg (Mstr("Starting least-connections dispatcher\n"));
    
    bool found = false;
    unsigned best_weighted = 0, t = 0;

    for (unsigned i = 0; i < targetlist.size(); i++) {
	if (! balancer.backend(targetlist[i]).available())
	    continue;
	unsigned this_weight =
	    (balancer.backend(targetlist[i]).connections() +
	     IPStore::anticipated(targetlist[i])) *
	    balancer.backend(targetlist[i]).adjustedweight();
	if (!found || this_weight < best_weighted) {
	    t = targetlist[i];
	    best_weighted = this_weight;
	    found = true;
	}
    }


    if (!found)
	throw Error("Least-connections algorithm: no available back ends");
    return (t);
}
